
/* test3.c -- CSR in one branch of conditional,
   function call in the other, at top level.
 */

#include <stdio.h>

void G(int* p1, int n) {
  printf("G: *p1=%d, n=%d\n", *p1, n);
  *p1 = (*p1) * n;
}

int F(int a, int b, int c) {
  int d=0, e=0, f=0, g=0;

  printf("0: a=%d, b=%d, c=%d\n", a, b, c);

  if (c > b) {
    d = a+1;
    e = c-2;
    f = b*3;
    g = f*e*d - (b/c)*(d*d - e + 1);
    a = g*d;
    c = c - 1;
  } else {
   G(&a, c-1);
  }

  b = c;
  a = b + 1;
  c = a*a + b*b;

  printf("1: a=%d, b=%d, c=%d\n", a, b, c);
  printf("1: d=%d, e=%d, f=%d\n", d, e, f);
  printf("1: g=%d\n", g);
}

int main() {
  printf("main: F(1,2,3)\n");
  F(1, 2, 3);
  printf("main: F(3,2,1)\n");
  F(3, 2, 1);
  return 0;
}
