
/* test6b.c --
   CSR in one branch of conditional, function call in the other,
   in depth 1 loop inside one branch of conditional.
 */

#include <stdio.h>

void G(int* p1, int n) {
  *p1 = (*p1) * n;
}

int F(int nn, int a, int b, int c) {
  int d=0, e=0, f=0, g=0;
  int i;

  printf("F.0: nn=%d, a=%d, b=%d, c=%d\n", nn, a, b, c);

  if (a < b) {
    a = b + c;
    b = b * c;
    for (i = 0; i < nn; ++i) {
      if (c > b) {
        d = a+1;
        e = c-2;
        f = b*3;
        g = f*e*d - (b/c)*(d*d - e + 1);
        a = g*d;
        c = c - 1;
      } else {
        c = c + 1;
        G(&a, c*c);
      }
    }
  } else {
    G(&c, a*b + c);
  }

  b = c;
  a = b + 1;
  c = a*a + b*b;

  printf("F.1: a=%d, b=%d, c=%d\n", a, b, c);
  printf("F.1: d=%d, e=%d, f=%d\n", d, e, f);
  printf("F.1: g=%d\n", g);
}

int main() {
  F(2, 1, 2, 3);
  F(2, 3, 2, 1);
  return 0;
}
