
/* test4.c --
   CSR in one branch of conditional, function call in the other,
   in loop at top level.
 */

#include <stdio.h>

void G(int* p1, int n) {
  *p1 = (*p1) * n;
}

int F(int nn, int a, int b, int c) {
  int d=0, e=0, f=0, g=0;
  int i;

  printf("F.0: nn=%d, a=%d, b=%d, c=%d\n", nn, a, b, c);

  for (i = 0; i < nn; ++i) {
    if (c > b) {
      d = a+1;
      e = c-2;
      f = b*3;
      g = f*e*d - (b/c)*(d*d - e + 1);
      a = g*d;
      c = c - 1;
    } else {
      c = c + 1;
      G(&a, c*1);
    }
  }

  b = c;
  a = b + 1;
  c = a*a + b*b;

  printf("F.1: a=%d, b=%d, c=%d\n", a, b, c);
  printf("F.1: d=%d, e=%d, f=%d\n", d, e, f);
  printf("F.1: g=%d\n", g);
}

int main() {
  F(4, 1, 2, 3);
  return 0;
}
